# Generated by sila2.code_generator; sila2.__version__: 0.9.2
from __future__ import annotations

from abc import ABC, abstractmethod
from queue import Queue
from typing import TYPE_CHECKING, Optional, Union

from sila2.server import FeatureImplementationBase, MetadataDict

from .stirrercontroller_types import SetRPM_Responses

if TYPE_CHECKING:
    from ...server import Server


class StirrerControllerBase(FeatureImplementationBase, ABC):
    parent_server: Server

    _SpeedRPM_producer_queue: Queue[Union[float, Exception]]
    _SpeedRPM_current_value: float

    def __init__(self, parent_server: Server):
        """

        Controlling a stirrer.

        """
        super().__init__(parent_server=parent_server)

        self._SpeedRPM_producer_queue = Queue()

    def update_SpeedRPM(self, SpeedRPM: float, queue: Optional[Queue[float]] = None) -> None:
        """
        Current Speed in RPM

        This method updates the observable property 'SpeedRPM'.

        :param queue: The queue to send updates to. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._SpeedRPM_producer_queue
            self._SpeedRPM_current_value = SpeedRPM
        queue.put(SpeedRPM)

    def SpeedRPM_on_subscription(self, *, metadata: MetadataDict) -> Optional[Queue[float]]:
        """
        Current Speed in RPM

        This method is called when a client subscribes to the observable property 'SpeedRPM'

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Optional `Queue` that should be used for updating this property.
            If None, the default Queue will be used.
        """
        pass

    def abort_SpeedRPM_subscriptions(self, error: Exception, queue: Optional[Queue[float]] = None) -> None:
        """
        Current Speed in RPM

        This method aborts subscriptions to the observable property 'SpeedRPM'.

        :param error: The Exception to be sent to the subscribing client.
            If it is no DefinedExecutionError or UndefinedExecutionError, it will be wrapped in an UndefinedExecutionError.
        :param queue: The queue to abort. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._SpeedRPM_producer_queue
        queue.put(error)

    @property
    def current_SpeedRPM(self) -> float:
        try:
            return self._SpeedRPM_current_value
        except AttributeError:
            raise AttributeError("Observable property SpeedRPM has never been set")

    @abstractmethod
    def SetRPM(self, Speed: float, *, metadata: MetadataDict) -> SetRPM_Responses:
        """
        Set stirrer speed in rounds per minute


        :param Speed: Speed in Rounds per Minute

        :param metadata: The SiLA Client Metadata attached to the call

        """
        pass
